local math_random = math.random
local hardknock1 = audio_stream_load("hardknock1.ogg")
local hardknock2 = audio_stream_load("hardknock2.ogg")
local hardknock3 = audio_stream_load("hardknock3.ogg")
local incannon1 = audio_stream_load("incannon1.ogg")
local incannon2 = audio_stream_load("incannon2.ogg")
local incannon3 = audio_stream_load("incannon3.ogg")
local squished1 = audio_stream_load("squished1.ogg")
local squished2 = audio_stream_load("squished2.ogg")
local squished3 = audio_stream_load("squished3.ogg")
local dive1 = audio_stream_load("dive1.ogg")
local dive2 = audio_stream_load("dive2.ogg")
local star1 = audio_stream_load("star1.ogg")
local star2 = audio_stream_load("star2.ogg")
local burnjump1 = audio_stream_load("burnjump1.ogg")
local burnjump2 = audio_stream_load("burnjump2.ogg")
local skills1 = audio_stream_load("skills1.ogg")
local skills2 = audio_stream_load("skills2.ogg")
local skills3 = audio_stream_load("skills3.ogg")
local bowsergrab1 = audio_stream_load("bowsergrab1.ogg")

		--- @param m MarioState
        function on_narrator1_action(m)
            --- Hard Knockbacks
            if m.playerIndex == 0 and math_random(0, 1) == 1 then 
                if m.action == ACT_HARD_BACKWARD_GROUND_KB or m.action == ACT_HARD_FORWARD_GROUND_KB then
                    audio_stream_play(hardknock1, false, 1)
                    audio_stream_set_looping(hardknock1, false)   
                end
            else
                if m.playerIndex == 0 and math_random(0, 1) == 1 then
                    if m.action == ACT_HARD_BACKWARD_GROUND_KB or m.action == ACT_HARD_FORWARD_GROUND_KB then
                        audio_stream_play(hardknock2, false, 1)
                        audio_stream_set_looping(hardknock2, false)
                end
            else
                if m.playerIndex == 0 then
                    if m.action == ACT_HARD_BACKWARD_GROUND_KB or m.action == ACT_HARD_FORWARD_GROUND_KB then
                        audio_stream_play(hardknock3, false, 1)
                        audio_stream_set_looping(hardknock3, false)
                end
            end
            end
            end
        end

        hook_event(HOOK_ON_SET_MARIO_ACTION, on_narrator1_action)

        function on_narrator2_action(m)
            --- In Cannon
            if m.playerIndex == 0 and math_random(0, 1) == 1 then 
                if m.action == ACT_IN_CANNON then
                    audio_stream_play(incannon1, false, 1)
                    audio_stream_set_looping(incannon1, false)   
                end
            else
                if m.playerIndex == 0 and math_random(0, 1) == 1 then
                    if m.action == ACT_IN_CANNON then
                        audio_stream_play(incannon2, false, 1)
                        audio_stream_set_looping(incannon2, false)
                end
            else
                if m.playerIndex == 0 then
                    if m.action == ACT_IN_CANNON then
                        audio_stream_play(incannon3, false, 1)
                        audio_stream_set_looping(incannon3, false)
                end
            end
            end
            end
        end

        hook_event(HOOK_ON_SET_MARIO_ACTION, on_narrator2_action)

        function on_narrator3_action(m)
            --- Squished
            if m.playerIndex == 0 and math_random(0, 1) == 1 then 
                if m.action == ACT_SQUISHED then
                    audio_stream_play(squished1, false, 1)
                    audio_stream_set_looping(squished1, false)   
                end
            else
                if m.playerIndex == 0 and math_random(0, 1) == 1 then
                    if m.action == ACT_SQUISHED then
                        audio_stream_play(squished2, false, 1)
                        audio_stream_set_looping(squished2, false)
                end
            else
                if m.playerIndex == 0 then
                    if m.action == ACT_SQUISHED then
                        audio_stream_play(squished3, false, 1)
                        audio_stream_set_looping(squished3, false)
                end
            end
            end
            end
        end

        hook_event(HOOK_ON_SET_MARIO_ACTION, on_narrator3_action)

        function on_narrator4_action(m)
            --- Diving
            if m.playerIndex == 0 and math_random(0, 10) == 10 then 
                if m.action == ACT_DIVE then
                    audio_stream_play(dive1, false, 1)
                    audio_stream_set_looping(dive1, false)   
                end
            else
                if m.playerIndex == 0 and math_random(0, 10) == 10 then
                    if m.action == ACT_DIVE then
                        audio_stream_play(dive2, false, 1)
                        audio_stream_set_looping(dive2, false)
                end
            end
            end
        end

        hook_event(HOOK_ON_SET_MARIO_ACTION, on_narrator4_action)

        function on_narrator5_action(m)
            --- Grabbing Stars
            if m.playerIndex == 0 and math_random(0, 1) == 1 then 
                if m.action == ACT_STAR_DANCE_EXIT or m.action == ACT_STAR_DANCE_NO_EXIT or m.action == ACT_STAR_DANCE_WATER then
                    audio_stream_play(star1, false, 1)
                    audio_stream_set_looping(star1, false)   
                end
            else
                if m.playerIndex == 0 and math_random(0, 1) == 1 then
                    if m.action == ACT_STAR_DANCE_EXIT or m.action == ACT_STAR_DANCE_NO_EXIT or m.action == ACT_STAR_DANCE_WATER or m.action == ACT_FALL_AFTER_STAR_GRAB then
                        audio_stream_play(star2, false, 1)
                        audio_stream_set_looping(star2, false)
                end
            end
            end
        end

        hook_event(HOOK_ON_SET_MARIO_ACTION, on_narrator5_action)

        function on_narrator6_action(m)
            --- Lava Boost
            if m.playerIndex == 0 and math_random(0, 5) == 5 then 
                if m.action == ACT_LAVA_BOOST then
                    audio_stream_play(burnjump1, false, 1)
                    audio_stream_set_looping(burnjump1, false)   
                end
            else
                if m.playerIndex == 0 and math_random(0, 5) == 5 then
                    if m.action == ACT_LAVA_BOOST then
                        audio_stream_play(burnjump2, false, 1)
                        audio_stream_set_looping(burnjump2, false)
                end
            end
            end
        end

        hook_event(HOOK_ON_SET_MARIO_ACTION, on_narrator6_action)

        function on_narrator7_action(m)
            --- Skills
            if m.playerIndex == 0 and math_random(0, 13) == 13 then 
                if m.action == ACT_TRIPLE_JUMP or m.action == ACT_SIDE_FLIP or m.action == ACT_SLIDE_KICK then
                    audio_stream_play(skills1, false, 1)
                    audio_stream_set_looping(skills1, false)   
                end
            else
                if m.playerIndex == 0 and math_random(0, 13) == 13 then
                    if m.action == ACT_TRIPLE_JUMP or m.action == ACT_SIDE_FLIP or m.action == ACT_SLIDE_KICK then
                        audio_stream_play(skills2, false, 1)
                        audio_stream_set_looping(skills2, false)
                end
            else
                if m.playerIndex == 0 and math_random(0, 13) == 13 then
                    if m.action == ACT_TRIPLE_JUMP or m.action == ACT_SIDE_FLIP or m.action == ACT_SLIDE_KICK then
                        audio_stream_play(skills3, false, 1)
                        audio_stream_set_looping(skills3, false)
                end
            end
            end
            end
        end

        hook_event(HOOK_ON_SET_MARIO_ACTION, on_narrator7_action)

        function on_narrator8_action(m)
            --- Bowser Grabbing
            if m.playerIndex == 0 and math_random(0, 2) == 2 then 
                if m.action == ACT_PICKING_UP_BOWSER then
                    audio_stream_play(bowsergrab1, false, 1)
                    audio_stream_set_looping(bowsergrab1, false)   
                end
            end
        end

        hook_event(HOOK_ON_SET_MARIO_ACTION, on_narrator8_action)